    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.util.GregorianCalendar

    java.lang.Object
       |
       +----java.util.Calendar
               |
               +----java.util.GregorianCalendar

public class GregorianCalendar
extends Calendar

`GregorianCalendar` is a concrete subclass of `Calendar` and provides the standard calendar used by most of the world.

The standard (Gregorian) calendar has 2 eras, BC and AD.

This implementation handles a single discontinuity, which corresponds by default to the date the Gregorian calendar was instituted (October 15, 1582 in some countries, later in others). This cutover date may be changed by the caller.

Prior to the institution of the Gregorian calendar, New Year's Day was March 25. To avoid confusion, this calendar always uses January 1. A manual adjustment may be made if desired for dates that are prior to the Gregorian changeover and which fall between January 1 and March 24.

Example:

>      // get the supported ids for GMT-08:00 (Pacific Standard Time)
>      String[] ids = TimeZone.getAvailableIDs(-8 * 60 * 60 * 1000);
>      // if no ids were returned, something is wrong. get out.
>      if (ids.length == 0)
>          System.exit(0);
>       // begin output
>      System.out.println("Current Time");
>      // create a Pacific Standard Time time zone
>      SimpleTimeZone pdt = new SimpleTimeZone(-8 * 60 * 60 * 1000, ids[0]);
>      // set up rules for daylight savings time
>      pdt.setStartRule(Calendar.APRIL, 1, Calendar.SUNDAY, 2 * 60 * 60 * 1000);
>      pdt.setEndRule(Calendar.OCTOBER, -1, Calendar.SUNDAY, 2 * 60 * 60 * 1000);
>      // create a GregorianCalendar with the Pacific Daylight time zone
>      // and the current date and time
>      Calendar calendar = new GregorianCalendar(pdt);
>      Date trialTime = new Date();
>      calendar.setTime(trialTime);
>      // print out a bunch of interesting things
>      System.out.println("ERA: " + calendar.get(Calendar.ERA));
>      System.out.println("YEAR: " + calendar.get(Calendar.YEAR));
>      System.out.println("MONTH: " + calendar.get(Calendar.MONTH));
>      System.out.println("WEEK_OF_YEAR: " + calendar.get(Calendar.WEEK_OF_YEAR));
>      System.out.println("WEEK_OF_MONTH: " + calendar.get(Calendar.WEEK_OF_MONTH));
>      System.out.println("DATE: " + calendar.get(Calendar.DATE));
>      System.out.println("DAY_OF_MONTH: " + calendar.get(Calendar.DAY_OF_MONTH));
>      System.out.println("DAY_OF_YEAR: " + calendar.get(Calendar.DAY_OF_YEAR));
>      System.out.println("DAY_OF_WEEK: " + calendar.get(Calendar.DAY_OF_WEEK));
>      System.out.println("DAY_OF_WEEK_IN_MONTH: "
>                         + calendar.get(Calendar.DAY_OF_WEEK_IN_MONTH));
>      System.out.println("AM_PM: " + calendar.get(Calendar.AM_PM));
>      System.out.println("HOUR: " + calendar.get(Calendar.HOUR));
>      System.out.println("HOUR_OF_DAY: " + calendar.get(Calendar.HOUR_OF_DAY));
>      System.out.println("MINUTE: " + calendar.get(Calendar.MINUTE));
>      System.out.println("SECOND: " + calendar.get(Calendar.SECOND));
>      System.out.println("MILLISECOND: " + calendar.get(Calendar.MILLISECOND));
>      System.out.println("ZONE_OFFSET: "
>                         + (calendar.get(Calendar.ZONE_OFFSET)/(60*60*1000)));
>      System.out.println("DST_OFFSET: "
>                         + (calendar.get(Calendar.DST_OFFSET)/(60*60*1000)));
>      System.out.println("Current Time, with hour reset to 3");
>      calendar.clear(Calendar.HOUR_OF_DAY); // so doesn't override
>      calendar.set(Calendar.HOUR, 3);
>      System.out.println("ERA: " + calendar.get(Calendar.ERA));
>      System.out.println("YEAR: " + calendar.get(Calendar.YEAR));
>      System.out.println("MONTH: " + calendar.get(Calendar.MONTH));
>      System.out.println("WEEK_OF_YEAR: " + calendar.get(Calendar.WEEK_OF_YEAR));
>      System.out.println("WEEK_OF_MONTH: " + calendar.get(Calendar.WEEK_OF_MONTH));
>      System.out.println("DATE: " + calendar.get(Calendar.DATE));
>      System.out.println("DAY_OF_MONTH: " + calendar.get(Calendar.DAY_OF_MONTH));
>      System.out.println("DAY_OF_YEAR: " + calendar.get(Calendar.DAY_OF_YEAR));
>      System.out.println("DAY_OF_WEEK: " + calendar.get(Calendar.DAY_OF_WEEK));
>      System.out.println("DAY_OF_WEEK_IN_MONTH: "
>                         + calendar.get(Calendar.DAY_OF_WEEK_IN_MONTH));
>      System.out.println("AM_PM: " + calendar.get(Calendar.AM_PM));
>      System.out.println("HOUR: " + calendar.get(Calendar.HOUR));
>      System.out.println("HOUR_OF_DAY: " + calendar.get(Calendar.HOUR_OF_DAY));
>      System.out.println("MINUTE: " + calendar.get(Calendar.MINUTE));
>      System.out.println("SECOND: " + calendar.get(Calendar.SECOND));
>      System.out.println("MILLISECOND: " + calendar.get(Calendar.MILLISECOND));
>      System.out.println("ZONE_OFFSET: "
>             + (calendar.get(Calendar.ZONE_OFFSET)/(60*60*1000))); // in hours
>      System.out.println("DST_OFFSET: "
>             + (calendar.get(Calendar.DST_OFFSET)/(60*60*1000))); // in hours

See Also:
  Calendar, TimeZone

##

AD
  Useful constant for GregorianCalendar.
BC
  Useful constant for GregorianCalendar.

##

GregorianCalendar()
  Constructs a default GregorianCalendar using the current time in the default time zone with the default locale.
GregorianCalendar(int, int, int)
  Constructs a GregorianCalendar with the given date set in the default time zone with the default locale.
GregorianCalendar(int, int, int, int, int)
  Constructs a GregorianCalendar with the given date and time set for the default time zone with the default locale.
GregorianCalendar(int, int, int, int, int, int)
  Constructs a GregorianCalendar with the given date and time set for the default time zone with the default locale.
GregorianCalendar(Locale)
  Constructs a GregorianCalendar based on the current time in the default time zone with the given locale.
GregorianCalendar(TimeZone)
  Constructs a GregorianCalendar based on the current time in the given time zone with the default locale.
GregorianCalendar(TimeZone, Locale)
  Constructs a GregorianCalendar based on the current time in the given time zone with the given locale.

##

add(int, int)
  Overrides Calendar Date Arithmetic function.
after(Object)
  Compares the time field records.
before(Object)
  Compares the time field records.
computeFields()
  Overrides Calendar Converts UTC as milliseconds to time field values.
computeTime()
  Overrides Calendar Converts time field values to UTC as milliseconds.
equals(Object)
  Compares this calendar to the specified object.
getGreatestMinimum(int)
  Returns highest minimum value for the given field if varies.
getGregorianChange()
  Gets the Gregorian Calendar change date.
getLeastMaximum(int)
  Returns lowest maximum value for the given field if varies.
getMaximum(int)
  Returns maximum value for the given field.
getMinimum(int)
  Returns minimum value for the given field.
hashCode()
  Override hashCode.
isLeapYear(int)
  Determines if the given year is a leap year.
roll(int, boolean)
  Overrides Calendar Time Field Rolling function.
setGregorianChange(Date)
  Sets the GregorianCalendar change date.

##

BC

     public static final int BC

  Useful constant for GregorianCalendar.

AD

     public static final int AD

  Useful constant for GregorianCalendar.

##

GregorianCalendar

     public GregorianCalendar()

  Constructs a default GregorianCalendar using the current time in the default time zone with the default locale.

GregorianCalendar

     public GregorianCalendar(TimeZone zone)

  Constructs a GregorianCalendar based on the current time in the given time zone with the default locale.

  Parameters:
    zone - the given time zone.

GregorianCalendar

     public GregorianCalendar(Locale aLocale)

  Constructs a GregorianCalendar based on the current time in the default time zone with the given locale.

  Parameters:
    aLocale - the given locale.

GregorianCalendar

     public GregorianCalendar(TimeZone zone,
                              Locale aLocale)

  Constructs a GregorianCalendar based on the current time in the given time zone with the given locale.

  Parameters:
    zone - the given time zone.
    aLocale - the given locale.

GregorianCalendar

     public GregorianCalendar(int year,
                              int month,
                              int date)

  Constructs a GregorianCalendar with the given date set in the default time zone with the default locale.

  Parameters:
    year - the value used to set the YEAR time field in the calendar.
    month - the value used to set the MONTH time field in the calendar. Month value is 0-based. e.g., 0 for January.
    date - the value used to set the DATE time field in the calendar.

GregorianCalendar

     public GregorianCalendar(int year,
                              int month,
                              int date,
                              int hour,
                              int minute)

  Constructs a GregorianCalendar with the given date and time set for the default time zone with the default locale.

  Parameters:
    year - the value used to set the YEAR time field in the calendar.
    month - the value used to set the MONTH time field in the calendar. Month value is 0-based. e.g., 0 for January.
    date - the value used to set the DATE time field in the calendar.
    hour - the value used to set the HOUR_OF_DAY time field in the calendar.
    minute - the value used to set the MINUTE time field in the calendar.

GregorianCalendar

     public GregorianCalendar(int year,
                              int month,
                              int date,
                              int hour,
                              int minute,
                              int second)

  Constructs a GregorianCalendar with the given date and time set for the default time zone with the default locale.

  Parameters:
    year - the value used to set the YEAR time field in the calendar.
    month - the value used to set the MONTH time field in the calendar. Month value is 0-based. e.g., 0 for January.
    date - the value used to set the DATE time field in the calendar.
    hour - the value used to set the HOUR_OF_DAY time field in the calendar.
    minute - the value used to set the MINUTE time field in the calendar.
    second - the value used to set the SECOND time field in the calendar.

##

equals

     public boolean equals(Object obj)

  Compares this calendar to the specified object. The result is `true` if and only if the argument is not `null` and is a `Calendar` object that represents the same calendar as this object.

  Parameters:
    obj - the object to compare with.
  Returns:
    `true` if the objects are the same; `false` otherwise.
  Overrides:
    equals in class Calendar

before

     public boolean before(Object when)

  Compares the time field records. Equivalent to comparing result of conversion to UTC.

  Parameters:
    when - the Calendar to be compared with this Calendar.
  Returns:
    true if the current time of this Calendar is before the time of Calendar when; false otherwise.
  Overrides:
    before in class Calendar

after

     public boolean after(Object when)

  Compares the time field records. Equivalent to comparing result of conversion to UTC.

  Parameters:
    when - the Calendar to be compared with this Calendar.
  Returns:
    true if the current time of this Calendar is after the time of Calendar when; false otherwise.
  Overrides:
    after in class Calendar

setGregorianChange

     public void setGregorianChange(Date date)

  Sets the GregorianCalendar change date. This is the point when the switch from Julian dates to Gregorian dates occurred. Default is 00:00:00 local time, October 15, 1582. Previous to this time and date will be Julian dates.

  Parameters:
    date - the given Gregorian cutover date.

getGregorianChange

     public final Date getGregorianChange()

  Gets the Gregorian Calendar change date. This is the point when the switch from Julian dates to Gregorian dates occurred. Default is 00:00:00 local time, October 15, 1582. Previous to this time and date will be Julian dates.

  Returns:
    the Gregorian cutover time for this calendar.

isLeapYear

     public boolean isLeapYear(int year)

  Determines if the given year is a leap year. Returns true if the given year is a leap year.

  Parameters:
    year - the given year.
  Returns:
    true if the given year is a leap year; false otherwise.

computeFields

     protected void computeFields()

  Overrides Calendar Converts UTC as milliseconds to time field values. The time is not recomputed first; to recompute the time, then the fields, call the `complete` method.

  Overrides:
    computeFields in class Calendar
  See Also:
    complete

computeTime

     protected void computeTime()

  Overrides Calendar Converts time field values to UTC as milliseconds.

  Throws: IllegalArgumentException
    if any fields are invalid.
  Overrides:
    computeTime in class Calendar

hashCode

     public synchronized int hashCode()

  Override hashCode. Generates the hash code for the GregorianCalendar object

  Overrides:
    hashCode in class Object

add

     public void add(int field,
                     int amount)

  Overrides Calendar Date Arithmetic function. Adds the specified (signed) amount of time to the given time field, based on the calendar's rules.

  Parameters:
    field - the time field.
    amount - the amount of date or time to be added to the field.
  Throws: IllegalArgumentException
    if an unknown field is given.
  Overrides:
    add in class Calendar

roll

     public void roll(int field,
                      boolean up)

  Overrides Calendar Time Field Rolling function. Rolls (up/down) a single unit of time on the given time field.

  Parameters:
    field - the time field.
    up - Indicates if rolling up or rolling down the field value.
  Throws: IllegalArgumentException
    if an unknown field value is given.
  Overrides:
    roll in class Calendar

getMinimum

     public int getMinimum(int field)

  Returns minimum value for the given field. e.g. for Gregorian DAY_OF_MONTH, 1 Please see Calendar.getMinimum for descriptions on parameters and the return value.

  Overrides:
    getMinimum in class Calendar

getMaximum

     public int getMaximum(int field)

  Returns maximum value for the given field. e.g. for Gregorian DAY_OF_MONTH, 31 Please see Calendar.getMaximum for descriptions on parameters and the return value.

  Overrides:
    getMaximum in class Calendar

getGreatestMinimum

     public int getGreatestMinimum(int field)

  Returns highest minimum value for the given field if varies. Otherwise same as getMinimum(). For Gregorian, no difference. Please see Calendar.getGreatestMinimum for descriptions on parameters and the return value.

  Overrides:
    getGreatestMinimum in class Calendar

getLeastMaximum

     public int getLeastMaximum(int field)

  Returns lowest maximum value for the given field if varies. Otherwise same as getMaximum(). For Gregorian DAY_OF_MONTH, 28 Please see Calendar.getLeastMaximum for descriptions on parameters and the return value.

  Overrides:
    getLeastMaximum in class Calendar

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.